#include <stdio.h>
#include <stdlib.h>

/*************************************************
 *  @brief: This is a dynamic array is resized
 *          if it is too small.
 * 
 * ***********************************************/
class Array
{
private:
	double *pArray;
	int size;
public:
	Array(int size){
		this->size = size;
		pArray = new double[size];
	}
	// This function rezises the array
	void resize(int newSize){
		double *newArray = new double[newSize];

		for (int i=0;i<size; i++){
			newArray[i] = pArray[i];
		}
		delete[] pArray;
		pArray = newArray;
		size = newSize;

	}
	// This function handles Array index out of bounds
	double &operator[](const int index){
		if (index<0){
				printf("Array index (%d) out of bounds\n",index);
				exit(0);
		}
		if (index>=size){
			resize(index+100);
		}
		return pArray[index];
	}	
};